/* 
 * Copyright (C) 1999-2004 Joachim Wieland <joe@mcknight.de>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.
 */

#ifndef __FTP_DISKCACHE_H__
#define __FTP_DISKCACHE_H__

#include <time.h>
#include "../ftp_main.h"

#define CACHE_AVAILABLE			0
#define CACHE_NOTAVL_EXIST		1
#define CACHE_NOTAVL_SIZE		2
#define CACHE_NOTAVL_DATE		3
#define CACHE_NOTAVL_CHECKSUM		4
#define CACHE_NOTAVL_DEACTIVATED	5

struct cache_filestruct {
	char* host;
	int port;
	char* user;
	char* filepath;
	char* filename;
	unsigned long size;
	time_t date;
};


int diskcache_init(void);

int transfermode_diskcache_in(int fd_in,
				struct transfer_t* transfer,
				struct proxyinfo* pi);

int transfermode_diskcache_deinit_server(struct proxyinfo* pi,
					struct messagebuffer* msgbuf,
					struct ftp_message* server_msg);

int transfermode_diskcache_in_from_cache_init(const char* cmd,
					       const char** args,
					       struct proxyinfo* pi,
					       struct messagebuffer* msgbuf,
					       struct ftp_message* server_msg);

/* this is also used by ftp_squidcache.c */
char* getftpwd(struct proxyinfo*);

#endif /* __FTP_DISKCACHE_H__ */
