/* 
 * Copyright (C) 1999-2004 Joachim Wieland <joe@mcknight.de>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.
 */

#ifndef __JPROXYGW_SOCKETIO_H__
#define __JPROXYGW_SOCKETIO_H__

#include <stdarg.h>
#include "jproxygw.h"

int say(int, const char*);
int sayf(int, const char*, ...);

void err_time_readline(int fd);
void err_readline(int fd);

char* readline(int);
char* readline_timeout(int, int);
char* readline_check_timeout(int, int, int);

typedef int(*socketio_checkfunc_t)(struct transfer_t*, struct proxyinfo*);

ssize_t writeall(int, char*, size_t);
ssize_t writeall_checkfunc(int, char*, size_t,
				struct proxyinfo*,
				socketio_checkfunc_t);

ssize_t readall(int, char*, size_t*);
ssize_t readall_checkfunc(int, char*, size_t*,
				struct proxyinfo*,
				socketio_checkfunc_t);

int socketio_set_nonblocking(int fd);
int socketio_set_flags(int fd, int flags);

#endif
